<template>
  <div class="p-4" style="overflow-x: hidden">
    <h1>Route Detail</h1>
    <div class="row justify-content-between mb-5">
      <div class="col-12 col-lg-6 drop-shadow border-radius p-4">
        <div class="row">
          <div class="col-12 mb-2">
            <img
              src="https://upload.wikimedia.org/wikipedia/commons/thumb/8/87/Gent_Zuid_029.JPG/1280px-Gent_Zuid_029.JPG"
              class="route-image"
              alt="..."
            />
          </div>
          <div class="col-12 d-flex justify-content-between align-items-center">
            <h3>{{ roundData.name }}</h3>
            <div class="point">
              <Icon @click="editRound()" class="icons" icon="bx:edit" />
              <Icon
                v-if="!this.confirm"
                @click="confirmate()"
                class="icons"
                color="red"
                icon="pajamas:remove"
              />
              <Icon
                v-if="this.confirm"
                @click="deleteRound()"
                class="icons"
                icon="line-md:confirm"
                color="red"
              />
            </div>
          </div>
          <div class="col-12 d-flex-column align-items-center">
            <div class="d-flex align-items-center">
              <div class="h5 me-1">Zone</div>
              <div>{{ roundData.region.name }}</div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-12 col-lg-5 drop-shadow border-radius p-4">
        <div
          class="col-12 d-flex justify-content-between align-items-center mb-2"
        >
          <h3>Studenten in route</h3>
        </div>
        <div>
          <h5>Super Studenten</h5>
          <div
            class="row align-items-center mb-3"
            v-for="(user, index) in this.superStudents"
            :key="index"
          >
            <Icon class="profile-picture" icon="ei:user" />
            <div class="col d-flex">
              <div>{{ user.name }}</div>
            </div>
            <Icon
              @click="unattachUser(user.id)"
              class="profile-picture cross"
              icon="basil:cross-outline"
            />
          </div>
          <div v-if="this.superStudents.length == 0">
            <div class="col d-flex">
              <div>Geen super studenten</div>
            </div>
          </div>
          <hr />
          <h5>Studenten</h5>
          <div
            class="row align-items-center mb-3"
            v-for="(user, index) in this.students"
            :key="index"
          >
            <Icon class="profile-picture" icon="ei:user" />
            <div class="col d-flex">
              <div>{{ user.name }}</div>
            </div>
            <Icon
              @click="unattachUser(user.id)"
              class="profile-picture cross"
              icon="basil:cross-outline"
            />
          </div>
          <div v-if="this.students.length == 0">
            <div class="col d-flex">
              <div>Geen studenten</div>
            </div>
          </div>
        </div>
        <div>
          <label for="userSelect" class="h5 mb-1">Student toevoegen</label>
          <select
            id="userSelect"
            class="form-select"
            aria-label="Default select example"
            type="number"
            v-model="selectedUser"
          >
            <option v-for="user in totalUsers" :key="user.id" :value="user">
              {{ user.name }}
            </option>
          </select>
          <button @click="addUserToRoute" class="addButton">Toevoegen</button>
        </div>
      </div>
    </div>

    <div class="row justify-content-around mb-5">
      <div class="col-12 drop-shadow border-radius p-4">
        <h3>Gebouwen in route</h3>
        <div class="map mb-4">
          <RouteMapBox
            ref="map"
            :locations="buildings"
            :activeLocation="activebuildingIndex"
            @setActiveLocation="setActiveLocation"
          ></RouteMapBox>
        </div>
        <div class="d-flex aling-items-centoer mb-4">
          <ProgressTracker
            :tabs="buildings"
            :tabIndex="activebuildingIndex"
            class="w-100"
          />
        </div>
        <div>
          <div
            class="row p-1 pt-2 round-item"
            v-for="(building, index) in buildings"
            :class="activebuildingIndex == index ? 'active-round' : ''"
            :key="index"
            @click="setActiveLocationWithCenterChange(index)"
          >
            <div class="col flex-column py-2">
              <router-link
                class="round-item__link"
                :to="'/buildings/' + building.id"
                v-if="activebuildingIndex == index"
                ><h4 v-html="building.name"></h4
              ></router-link>
              <h4 v-html="building.name" v-else></h4>
              <div v-if="activebuildingIndex == index">
                <div>{{ building.adress }}</div>
                <div class="mb-2">
                  {{ building.zipcode }} - {{ building.city }}
                </div>
              </div>
            </div>
            <div
              v-if="activebuildingIndex == index"
              class="col-1 col-md-2 d-flex justify-content-end"
            >
              edit
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ProgressTracker from "./organisms/ProgressTracker.vue";
import RouteMapBox from "./molecules/RouteMapBox.vue";
import axios from "axios";
import store from "@/store/auth";
import { Icon } from "@iconify/vue";

export default {
  components: { ProgressTracker, Icon, RouteMapBox },
  data() {
    return {
      confirm: false,
      roundData: {},
      users: [],
      totalUsers: [],
      buildings: [
        {
          id: 0,
          name: "Sint-Michiels",
          adress: "thv Sint-Michielsplein 9",
          zipcode: "9000",
          city: "Gent",
          lon: 3.7099,
          lat: 51.0602,
          image:
            "https://images0.persgroep.net/rcs/0Rx0jhdGxQlgh5LTmJuKVTbL2PQ/diocontent/68956537/_fitwidth/694/?appId=21791a8992982cd8da851550a453bd7f&quality=0.8",
        },
        {
          id: 1,
          name: "Academie",
          adress: "Sint-Margrietstraat 11",
          zipcode: "9000",
          city: "Gent",
          lon: 4.7099,
          lat: 51.0602,
          image:
            "https://www.academie.gent/site/assets/files/1035/ams_0978_3dp_aca_20150724_beeld_a_noum_eb_8bit.1920x800.jpg",
        },
        {
          id: 2,
          name: "Alecon",
          adress: "Burgstraat 63",
          zipcode: "9000",
          city: "Gent",
          lon: 0,
          lat: 0,
          image:
            "https://vincentboutin.fr/wp-content/uploads/2020/09/alencon_renovation-centre_ville_inuits_paysagistes-19.jpg",
        },
        {
          id: 3,
          name: "Hoogstede",
          adress: "Brouwerstraat",
          zipcode: "9000",
          city: "Gent",
          lon: 0,
          lat: 0,
          image:
            "https://www.bouwbedrijfflore.be/wp-content/uploads/2018/07/10014-6.jpg",
        },
      ],

      route: {
        name: "Zone Gent-Zuid",
        routerounds: "0,1,2,3",
      },
      students: [],
      superStudents: [],
      activebuildingIndex: 0,
      selectedUser: null,
    };
  },
  created() {
    this.getRoundDetails();
  },
  methods: {
    confirmate() {
      this.confirm = true;
    },
    editRound() {
      this.$router.push({
        name: "editRoutes",
        params: { id: this.roundData.id },
      });
    },
    async deleteRound() {
      await axios.delete("/api/round/" + this.roundData.id).then((response) => {
        if (response.status === 200) {
          console.log("deleted");
          this.$router.push({
            name: "routes",
          });
        }
      });
    },
    async getRoundDetails() {
      this.users = [];
      store.commit("general/setLoading", true);
      try {
        await axios
          .get("/api/round/" + this.$route.params.id)
          .then(async (response) => {
            if (response.status === 200) {
              this.roundData = response.data;
              if (this.roundData.assignedUserIds.length > 0) {
                await this.roundData.assignedUserIds.forEach((user) => {
                  this.getUser(user);
                });
              } else {
                this.getUsers();
                this.filterStudents();
              }
            }
          })
          .then(() => this.getBuildings());
      } catch (error) {
        console.log(error);
      }
      //this.addMockData();
      store.commit("general/setLoading", false);
    },
    async getBuildings() {
      console.log(this.roundData.buildingIds);
      this.buildings = [];
      this.roundData.buildingIds.forEach(async (id) => {
        await axios.get("/api/building/" + id).then(async (response) => {
          this.buildings.push(response.data);
        });
      });
    },
    async getUser(id) {
      store.commit("general/setLoading", true);
      try {
        const response = await axios.get("/api/user/id/" + id);
        if (response.status === 200) {
          this.addUser(response.data);
        }
      } catch (error) {
        console.log(error);
      }
      store.commit("general/setLoading", false);
    },
    async getUsers() {
      store.commit("general/setLoading", true);
      try {
        const response = await axios.get("/api/user/all");
        if (response.status === 200) {
          this.addUsers(response.data);
        }
      } catch (error) {
        console.log(error);
      }
      store.commit("general/setLoading", false);
    },
    async addUserToRoute() {
      if (this.selectedUser) {
        const data = {
          userId: this.selectedUser.id,
          roundId: this.roundData.id,
        };
        await axios
          .post(
            "/api/assign/route",
            data, // the data to post
            {
              withCredentials: true,
              headers: {
                "Access-Control-Allow-Origin": "*",
                "Content-Type": "application/json",
              },
            }
          )
          .then(() => {
            this.getRoundDetails();
          });
        this.selectedUser = null;
      }
    },
    async unattachUser(userid) {
      const data = {
        userId: userid,
        roundId: this.roundData.id,
      };
      await axios
        .post(
          "/api/unassign/route",
          data, // the data to post
          {
            withCredentials: true,
            headers: {
              "Access-Control-Allow-Origin": "*",
              "Content-Type": "application/json",
            },
          }
        )
        .then(() => {
          this.getRoundDetails();
        });
    },
    addUsers(users) {
      this.totalUsers = [];
      users.forEach((user) => {
        if (
          user.role != "Admin" &&
          !this.isUserInStudents(user) &&
          !this.isUserInSuperStudents(user)
        ) {
          this.totalUsers.push(user);
        }
      });
    },
    isUserInStudents(user) {
      return this.students.some((student) => student.id === user.id);
    },
    isUserInSuperStudents(user) {
      return this.superStudents.some((student) => student.id === user.id);
    },
    addUser(user) {
      this.users.push(user);
      this.filterStudents();
    },
    filterStudents() {
      this.students = [];
      this.superStudents = [];
      this.users.forEach((user) => {
        if (user.role == "SuperStudent") {
          this.superStudents.push(user);
        } else {
          this.students.push(user);
        }
      });
      this.getUsers();
    },
    setActiveLocation(activeLocation) {
      this.activebuildingIndex = activeLocation;
    },
    setActiveLocationWithCenterChange(activeLocation) {
      this.activebuildingIndex = activeLocation;
      this.$refs.map.updateCenter(activeLocation);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "../assets/css/base.css";
@import "../assets/css/colors.css";

.route-image {
  max-height: 218px;
  object-fit: cover;
  width: 100%;
}

.icons {
  width: 35px;
  height: 35px;
  padding-left: 6px;
  padding-right: 6px;
}
.point :hover {
  cursor: pointer;
}

.profile-picture {
  border-radius: 50%;
  min-width: 50px;
  max-width: 80px;
  height: 100%;
  aspect-ratio: 1.5/1;
  object-fit: cover;
}

.cross {
  width: 50px;
}

.cross:hover {
  cursor: pointer;
}

.text-gray {
  color: #a5a5a5;
}

.map {
  width: 100%;
  min-height: 404px;
  background: rgba(lightblue, 0.5);
  /* background-image: url("https://static.joomlart.com/images/blog/2018/ja-open-street-map-101/transport-map.jpg"); */
  background-repeat: no-repeat;
  background-size: cover;
}
.addButton {
  margin-top: 1rem;
}

.round-item {
  transition: all 400ms;
  border-top: solid var(--light-grey) 1px;
  &:last-child {
    border-bottom: solid var(--light-grey) 1px;
  }
  &.active-round {
    background-color: var(--almost-white);
  }

  &__link {
    color: var(--almost-black);
    &:hover {
      color: var(--light-grey);
    }
  }
}
</style>
